# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['GitOpsApplicationsArgs', 'GitOpsApplications']

@pulumi.input_type
class GitOpsApplicationsArgs:
    def __init__(__self__, *,
                 account_id: pulumi.Input[str],
                 agent_id: pulumi.Input[str],
                 applications: pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]],
                 cluster_id: pulumi.Input[str],
                 org_id: pulumi.Input[str],
                 project_id: pulumi.Input[str],
                 repo_id: pulumi.Input[str],
                 identifier: Optional[pulumi.Input[str]] = None,
                 kind: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 options_remove_existing_finalizers: Optional[pulumi.Input[bool]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 query_project: Optional[pulumi.Input[str]] = None,
                 query_refresh: Optional[pulumi.Input[str]] = None,
                 query_repo: Optional[pulumi.Input[str]] = None,
                 query_resource_version: Optional[pulumi.Input[str]] = None,
                 query_selector: Optional[pulumi.Input[str]] = None,
                 request_cascade: Optional[pulumi.Input[bool]] = None,
                 request_name: Optional[pulumi.Input[str]] = None,
                 request_propagation_policy: Optional[pulumi.Input[str]] = None,
                 upsert: Optional[pulumi.Input[bool]] = None,
                 validate: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a GitOpsApplications resource.
        :param pulumi.Input[str] account_id: Account identifier of the GitOps application.
        :param pulumi.Input[str] agent_id: Agent identifier of the GitOps application.
        :param pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]] applications: Definition of the GitOps application resource.
        :param pulumi.Input[str] cluster_id: Cluster identifier of the GitOps application.
        :param pulumi.Input[str] org_id: Organization identifier of the GitOps application.
        :param pulumi.Input[str] project_id: Project identifier of the GitOps application.
        :param pulumi.Input[str] repo_id: Repository identifier of the GitOps application.
        :param pulumi.Input[str] identifier: Identifier of the GitOps application.
        :param pulumi.Input[str] kind: Kind of the GitOps application.
        :param pulumi.Input[str] name: Name of the GitOps application.
        :param pulumi.Input[bool] options_remove_existing_finalizers: Options to remove existing finalizers to delete the GitOps application.
        :param pulumi.Input[str] project: Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        :param pulumi.Input[str] query_project: Project names to filter the corresponding GitOps applications.
        :param pulumi.Input[str] query_refresh: Forces the GitOps application to reconcile when set to true.
        :param pulumi.Input[str] query_repo: Repo URL to restrict returned list applications.
        :param pulumi.Input[str] query_resource_version: Shows modifications after a version that is specified with a watch call.
        :param pulumi.Input[str] query_selector: Filters GitOps applications corresponding to the labels.
        :param pulumi.Input[bool] request_cascade: Request cascade to delete the GitOps application.
        :param pulumi.Input[str] request_name: Request name to delete the GitOps application.
        :param pulumi.Input[str] request_propagation_policy: Request propagation policy to delete the GitOps application.
        :param pulumi.Input[bool] upsert: Indicates if the GitOps application should be updated if existing and inserted if not.
        :param pulumi.Input[bool] validate: Indicates if the GitOps application has to be validated.
        """
        pulumi.set(__self__, "account_id", account_id)
        pulumi.set(__self__, "agent_id", agent_id)
        pulumi.set(__self__, "applications", applications)
        pulumi.set(__self__, "cluster_id", cluster_id)
        pulumi.set(__self__, "org_id", org_id)
        pulumi.set(__self__, "project_id", project_id)
        pulumi.set(__self__, "repo_id", repo_id)
        if identifier is not None:
            pulumi.set(__self__, "identifier", identifier)
        if kind is not None:
            pulumi.set(__self__, "kind", kind)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if options_remove_existing_finalizers is not None:
            pulumi.set(__self__, "options_remove_existing_finalizers", options_remove_existing_finalizers)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if query_project is not None:
            pulumi.set(__self__, "query_project", query_project)
        if query_refresh is not None:
            pulumi.set(__self__, "query_refresh", query_refresh)
        if query_repo is not None:
            pulumi.set(__self__, "query_repo", query_repo)
        if query_resource_version is not None:
            pulumi.set(__self__, "query_resource_version", query_resource_version)
        if query_selector is not None:
            pulumi.set(__self__, "query_selector", query_selector)
        if request_cascade is not None:
            pulumi.set(__self__, "request_cascade", request_cascade)
        if request_name is not None:
            pulumi.set(__self__, "request_name", request_name)
        if request_propagation_policy is not None:
            pulumi.set(__self__, "request_propagation_policy", request_propagation_policy)
        if upsert is not None:
            pulumi.set(__self__, "upsert", upsert)
        if validate is not None:
            pulumi.set(__self__, "validate", validate)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Input[str]:
        """
        Account identifier of the GitOps application.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="agentId")
    def agent_id(self) -> pulumi.Input[str]:
        """
        Agent identifier of the GitOps application.
        """
        return pulumi.get(self, "agent_id")

    @agent_id.setter
    def agent_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "agent_id", value)

    @property
    @pulumi.getter
    def applications(self) -> pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]]:
        """
        Definition of the GitOps application resource.
        """
        return pulumi.get(self, "applications")

    @applications.setter
    def applications(self, value: pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]]):
        pulumi.set(self, "applications", value)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        Cluster identifier of the GitOps application.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Input[str]:
        """
        Organization identifier of the GitOps application.
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "org_id", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[str]:
        """
        Project identifier of the GitOps application.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="repoId")
    def repo_id(self) -> pulumi.Input[str]:
        """
        Repository identifier of the GitOps application.
        """
        return pulumi.get(self, "repo_id")

    @repo_id.setter
    def repo_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "repo_id", value)

    @property
    @pulumi.getter
    def identifier(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the GitOps application.
        """
        return pulumi.get(self, "identifier")

    @identifier.setter
    def identifier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "identifier", value)

    @property
    @pulumi.getter
    def kind(self) -> Optional[pulumi.Input[str]]:
        """
        Kind of the GitOps application.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the GitOps application.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="optionsRemoveExistingFinalizers")
    def options_remove_existing_finalizers(self) -> Optional[pulumi.Input[bool]]:
        """
        Options to remove existing finalizers to delete the GitOps application.
        """
        return pulumi.get(self, "options_remove_existing_finalizers")

    @options_remove_existing_finalizers.setter
    def options_remove_existing_finalizers(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "options_remove_existing_finalizers", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="queryProject")
    def query_project(self) -> Optional[pulumi.Input[str]]:
        """
        Project names to filter the corresponding GitOps applications.
        """
        return pulumi.get(self, "query_project")

    @query_project.setter
    def query_project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_project", value)

    @property
    @pulumi.getter(name="queryRefresh")
    def query_refresh(self) -> Optional[pulumi.Input[str]]:
        """
        Forces the GitOps application to reconcile when set to true.
        """
        return pulumi.get(self, "query_refresh")

    @query_refresh.setter
    def query_refresh(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_refresh", value)

    @property
    @pulumi.getter(name="queryRepo")
    def query_repo(self) -> Optional[pulumi.Input[str]]:
        """
        Repo URL to restrict returned list applications.
        """
        return pulumi.get(self, "query_repo")

    @query_repo.setter
    def query_repo(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_repo", value)

    @property
    @pulumi.getter(name="queryResourceVersion")
    def query_resource_version(self) -> Optional[pulumi.Input[str]]:
        """
        Shows modifications after a version that is specified with a watch call.
        """
        return pulumi.get(self, "query_resource_version")

    @query_resource_version.setter
    def query_resource_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_resource_version", value)

    @property
    @pulumi.getter(name="querySelector")
    def query_selector(self) -> Optional[pulumi.Input[str]]:
        """
        Filters GitOps applications corresponding to the labels.
        """
        return pulumi.get(self, "query_selector")

    @query_selector.setter
    def query_selector(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_selector", value)

    @property
    @pulumi.getter(name="requestCascade")
    def request_cascade(self) -> Optional[pulumi.Input[bool]]:
        """
        Request cascade to delete the GitOps application.
        """
        return pulumi.get(self, "request_cascade")

    @request_cascade.setter
    def request_cascade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "request_cascade", value)

    @property
    @pulumi.getter(name="requestName")
    def request_name(self) -> Optional[pulumi.Input[str]]:
        """
        Request name to delete the GitOps application.
        """
        return pulumi.get(self, "request_name")

    @request_name.setter
    def request_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "request_name", value)

    @property
    @pulumi.getter(name="requestPropagationPolicy")
    def request_propagation_policy(self) -> Optional[pulumi.Input[str]]:
        """
        Request propagation policy to delete the GitOps application.
        """
        return pulumi.get(self, "request_propagation_policy")

    @request_propagation_policy.setter
    def request_propagation_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "request_propagation_policy", value)

    @property
    @pulumi.getter
    def upsert(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates if the GitOps application should be updated if existing and inserted if not.
        """
        return pulumi.get(self, "upsert")

    @upsert.setter
    def upsert(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "upsert", value)

    @property
    @pulumi.getter
    def validate(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates if the GitOps application has to be validated.
        """
        return pulumi.get(self, "validate")

    @validate.setter
    def validate(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "validate", value)


@pulumi.input_type
class _GitOpsApplicationsState:
    def __init__(__self__, *,
                 account_id: Optional[pulumi.Input[str]] = None,
                 agent_id: Optional[pulumi.Input[str]] = None,
                 applications: Optional[pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 identifier: Optional[pulumi.Input[str]] = None,
                 kind: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 options_remove_existing_finalizers: Optional[pulumi.Input[bool]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 query_project: Optional[pulumi.Input[str]] = None,
                 query_refresh: Optional[pulumi.Input[str]] = None,
                 query_repo: Optional[pulumi.Input[str]] = None,
                 query_resource_version: Optional[pulumi.Input[str]] = None,
                 query_selector: Optional[pulumi.Input[str]] = None,
                 repo_id: Optional[pulumi.Input[str]] = None,
                 request_cascade: Optional[pulumi.Input[bool]] = None,
                 request_name: Optional[pulumi.Input[str]] = None,
                 request_propagation_policy: Optional[pulumi.Input[str]] = None,
                 upsert: Optional[pulumi.Input[bool]] = None,
                 validate: Optional[pulumi.Input[bool]] = None):
        """
        Input properties used for looking up and filtering GitOpsApplications resources.
        :param pulumi.Input[str] account_id: Account identifier of the GitOps application.
        :param pulumi.Input[str] agent_id: Agent identifier of the GitOps application.
        :param pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]] applications: Definition of the GitOps application resource.
        :param pulumi.Input[str] cluster_id: Cluster identifier of the GitOps application.
        :param pulumi.Input[str] identifier: Identifier of the GitOps application.
        :param pulumi.Input[str] kind: Kind of the GitOps application.
        :param pulumi.Input[str] name: Name of the GitOps application.
        :param pulumi.Input[bool] options_remove_existing_finalizers: Options to remove existing finalizers to delete the GitOps application.
        :param pulumi.Input[str] org_id: Organization identifier of the GitOps application.
        :param pulumi.Input[str] project: Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        :param pulumi.Input[str] project_id: Project identifier of the GitOps application.
        :param pulumi.Input[str] query_project: Project names to filter the corresponding GitOps applications.
        :param pulumi.Input[str] query_refresh: Forces the GitOps application to reconcile when set to true.
        :param pulumi.Input[str] query_repo: Repo URL to restrict returned list applications.
        :param pulumi.Input[str] query_resource_version: Shows modifications after a version that is specified with a watch call.
        :param pulumi.Input[str] query_selector: Filters GitOps applications corresponding to the labels.
        :param pulumi.Input[str] repo_id: Repository identifier of the GitOps application.
        :param pulumi.Input[bool] request_cascade: Request cascade to delete the GitOps application.
        :param pulumi.Input[str] request_name: Request name to delete the GitOps application.
        :param pulumi.Input[str] request_propagation_policy: Request propagation policy to delete the GitOps application.
        :param pulumi.Input[bool] upsert: Indicates if the GitOps application should be updated if existing and inserted if not.
        :param pulumi.Input[bool] validate: Indicates if the GitOps application has to be validated.
        """
        if account_id is not None:
            pulumi.set(__self__, "account_id", account_id)
        if agent_id is not None:
            pulumi.set(__self__, "agent_id", agent_id)
        if applications is not None:
            pulumi.set(__self__, "applications", applications)
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if identifier is not None:
            pulumi.set(__self__, "identifier", identifier)
        if kind is not None:
            pulumi.set(__self__, "kind", kind)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if options_remove_existing_finalizers is not None:
            pulumi.set(__self__, "options_remove_existing_finalizers", options_remove_existing_finalizers)
        if org_id is not None:
            pulumi.set(__self__, "org_id", org_id)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if query_project is not None:
            pulumi.set(__self__, "query_project", query_project)
        if query_refresh is not None:
            pulumi.set(__self__, "query_refresh", query_refresh)
        if query_repo is not None:
            pulumi.set(__self__, "query_repo", query_repo)
        if query_resource_version is not None:
            pulumi.set(__self__, "query_resource_version", query_resource_version)
        if query_selector is not None:
            pulumi.set(__self__, "query_selector", query_selector)
        if repo_id is not None:
            pulumi.set(__self__, "repo_id", repo_id)
        if request_cascade is not None:
            pulumi.set(__self__, "request_cascade", request_cascade)
        if request_name is not None:
            pulumi.set(__self__, "request_name", request_name)
        if request_propagation_policy is not None:
            pulumi.set(__self__, "request_propagation_policy", request_propagation_policy)
        if upsert is not None:
            pulumi.set(__self__, "upsert", upsert)
        if validate is not None:
            pulumi.set(__self__, "validate", validate)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[pulumi.Input[str]]:
        """
        Account identifier of the GitOps application.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter(name="agentId")
    def agent_id(self) -> Optional[pulumi.Input[str]]:
        """
        Agent identifier of the GitOps application.
        """
        return pulumi.get(self, "agent_id")

    @agent_id.setter
    def agent_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agent_id", value)

    @property
    @pulumi.getter
    def applications(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]]]:
        """
        Definition of the GitOps application resource.
        """
        return pulumi.get(self, "applications")

    @applications.setter
    def applications(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GitOpsApplicationsApplicationArgs']]]]):
        pulumi.set(self, "applications", value)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        Cluster identifier of the GitOps application.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter
    def identifier(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the GitOps application.
        """
        return pulumi.get(self, "identifier")

    @identifier.setter
    def identifier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "identifier", value)

    @property
    @pulumi.getter
    def kind(self) -> Optional[pulumi.Input[str]]:
        """
        Kind of the GitOps application.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the GitOps application.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="optionsRemoveExistingFinalizers")
    def options_remove_existing_finalizers(self) -> Optional[pulumi.Input[bool]]:
        """
        Options to remove existing finalizers to delete the GitOps application.
        """
        return pulumi.get(self, "options_remove_existing_finalizers")

    @options_remove_existing_finalizers.setter
    def options_remove_existing_finalizers(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "options_remove_existing_finalizers", value)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> Optional[pulumi.Input[str]]:
        """
        Organization identifier of the GitOps application.
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org_id", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[str]]:
        """
        Project identifier of the GitOps application.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="queryProject")
    def query_project(self) -> Optional[pulumi.Input[str]]:
        """
        Project names to filter the corresponding GitOps applications.
        """
        return pulumi.get(self, "query_project")

    @query_project.setter
    def query_project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_project", value)

    @property
    @pulumi.getter(name="queryRefresh")
    def query_refresh(self) -> Optional[pulumi.Input[str]]:
        """
        Forces the GitOps application to reconcile when set to true.
        """
        return pulumi.get(self, "query_refresh")

    @query_refresh.setter
    def query_refresh(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_refresh", value)

    @property
    @pulumi.getter(name="queryRepo")
    def query_repo(self) -> Optional[pulumi.Input[str]]:
        """
        Repo URL to restrict returned list applications.
        """
        return pulumi.get(self, "query_repo")

    @query_repo.setter
    def query_repo(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_repo", value)

    @property
    @pulumi.getter(name="queryResourceVersion")
    def query_resource_version(self) -> Optional[pulumi.Input[str]]:
        """
        Shows modifications after a version that is specified with a watch call.
        """
        return pulumi.get(self, "query_resource_version")

    @query_resource_version.setter
    def query_resource_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_resource_version", value)

    @property
    @pulumi.getter(name="querySelector")
    def query_selector(self) -> Optional[pulumi.Input[str]]:
        """
        Filters GitOps applications corresponding to the labels.
        """
        return pulumi.get(self, "query_selector")

    @query_selector.setter
    def query_selector(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "query_selector", value)

    @property
    @pulumi.getter(name="repoId")
    def repo_id(self) -> Optional[pulumi.Input[str]]:
        """
        Repository identifier of the GitOps application.
        """
        return pulumi.get(self, "repo_id")

    @repo_id.setter
    def repo_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "repo_id", value)

    @property
    @pulumi.getter(name="requestCascade")
    def request_cascade(self) -> Optional[pulumi.Input[bool]]:
        """
        Request cascade to delete the GitOps application.
        """
        return pulumi.get(self, "request_cascade")

    @request_cascade.setter
    def request_cascade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "request_cascade", value)

    @property
    @pulumi.getter(name="requestName")
    def request_name(self) -> Optional[pulumi.Input[str]]:
        """
        Request name to delete the GitOps application.
        """
        return pulumi.get(self, "request_name")

    @request_name.setter
    def request_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "request_name", value)

    @property
    @pulumi.getter(name="requestPropagationPolicy")
    def request_propagation_policy(self) -> Optional[pulumi.Input[str]]:
        """
        Request propagation policy to delete the GitOps application.
        """
        return pulumi.get(self, "request_propagation_policy")

    @request_propagation_policy.setter
    def request_propagation_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "request_propagation_policy", value)

    @property
    @pulumi.getter
    def upsert(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates if the GitOps application should be updated if existing and inserted if not.
        """
        return pulumi.get(self, "upsert")

    @upsert.setter
    def upsert(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "upsert", value)

    @property
    @pulumi.getter
    def validate(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates if the GitOps application has to be validated.
        """
        return pulumi.get(self, "validate")

    @validate.setter
    def validate(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "validate", value)


class GitOpsApplications(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 agent_id: Optional[pulumi.Input[str]] = None,
                 applications: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GitOpsApplicationsApplicationArgs']]]]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 identifier: Optional[pulumi.Input[str]] = None,
                 kind: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 options_remove_existing_finalizers: Optional[pulumi.Input[bool]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 query_project: Optional[pulumi.Input[str]] = None,
                 query_refresh: Optional[pulumi.Input[str]] = None,
                 query_repo: Optional[pulumi.Input[str]] = None,
                 query_resource_version: Optional[pulumi.Input[str]] = None,
                 query_selector: Optional[pulumi.Input[str]] = None,
                 repo_id: Optional[pulumi.Input[str]] = None,
                 request_cascade: Optional[pulumi.Input[bool]] = None,
                 request_name: Optional[pulumi.Input[str]] = None,
                 request_propagation_policy: Optional[pulumi.Input[str]] = None,
                 upsert: Optional[pulumi.Input[bool]] = None,
                 validate: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        Resource for creating a Harness Gitops Application.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_harness as harness

        example = harness.platform.GitOpsApplications("example",
            applications=[harness.platform.GitOpsApplicationsApplicationArgs(
                metadatas=[harness.platform.GitOpsApplicationsApplicationMetadataArgs(
                    annotations={},
                    labels={
                        "harness.io/serviceRef": "service_id",
                        "harness.io/envRef": "env_id",
                    },
                    name="appname123",
                )],
                specs=[harness.platform.GitOpsApplicationsApplicationSpecArgs(
                    sync_policies=[harness.platform.GitOpsApplicationsApplicationSpecSyncPolicyArgs(
                        sync_options=[
                            "PrunePropagationPolicy=undefined",
                            "CreateNamespace=false",
                            "Validate=false",
                            "skipSchemaValidations=false",
                            "autoCreateNamespace=false",
                            "pruneLast=false",
                            "applyOutofSyncOnly=false",
                            "Replace=false",
                            "retry=false",
                        ],
                    )],
                    sources=[harness.platform.GitOpsApplicationsApplicationSpecSourceArgs(
                        target_revision="master",
                        repo_url="https://github.com/willycoll/argocd-example-apps.git",
                        path="helm-guestbook",
                    )],
                    destinations=[harness.platform.GitOpsApplicationsApplicationSpecDestinationArgs(
                        namespace="namespace-123",
                        server="https://1.3.4.5",
                    )],
                )],
            )],
            project_id="project_id",
            org_id="org_id",
            account_id="account_id",
            identifier="identifier",
            cluster_id="cluster_id",
            repo_id="repo_id",
            agent_id="agent_id")
        ```

        ## Import

        Import a Project level Gitops Application

        ```sh
        $ pulumi import harness:platform/gitOpsApplications:GitOpsApplications example <organization_id>/<project_id>/<agent_id>/<app_name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: Account identifier of the GitOps application.
        :param pulumi.Input[str] agent_id: Agent identifier of the GitOps application.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GitOpsApplicationsApplicationArgs']]]] applications: Definition of the GitOps application resource.
        :param pulumi.Input[str] cluster_id: Cluster identifier of the GitOps application.
        :param pulumi.Input[str] identifier: Identifier of the GitOps application.
        :param pulumi.Input[str] kind: Kind of the GitOps application.
        :param pulumi.Input[str] name: Name of the GitOps application.
        :param pulumi.Input[bool] options_remove_existing_finalizers: Options to remove existing finalizers to delete the GitOps application.
        :param pulumi.Input[str] org_id: Organization identifier of the GitOps application.
        :param pulumi.Input[str] project: Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        :param pulumi.Input[str] project_id: Project identifier of the GitOps application.
        :param pulumi.Input[str] query_project: Project names to filter the corresponding GitOps applications.
        :param pulumi.Input[str] query_refresh: Forces the GitOps application to reconcile when set to true.
        :param pulumi.Input[str] query_repo: Repo URL to restrict returned list applications.
        :param pulumi.Input[str] query_resource_version: Shows modifications after a version that is specified with a watch call.
        :param pulumi.Input[str] query_selector: Filters GitOps applications corresponding to the labels.
        :param pulumi.Input[str] repo_id: Repository identifier of the GitOps application.
        :param pulumi.Input[bool] request_cascade: Request cascade to delete the GitOps application.
        :param pulumi.Input[str] request_name: Request name to delete the GitOps application.
        :param pulumi.Input[str] request_propagation_policy: Request propagation policy to delete the GitOps application.
        :param pulumi.Input[bool] upsert: Indicates if the GitOps application should be updated if existing and inserted if not.
        :param pulumi.Input[bool] validate: Indicates if the GitOps application has to be validated.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GitOpsApplicationsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource for creating a Harness Gitops Application.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_harness as harness

        example = harness.platform.GitOpsApplications("example",
            applications=[harness.platform.GitOpsApplicationsApplicationArgs(
                metadatas=[harness.platform.GitOpsApplicationsApplicationMetadataArgs(
                    annotations={},
                    labels={
                        "harness.io/serviceRef": "service_id",
                        "harness.io/envRef": "env_id",
                    },
                    name="appname123",
                )],
                specs=[harness.platform.GitOpsApplicationsApplicationSpecArgs(
                    sync_policies=[harness.platform.GitOpsApplicationsApplicationSpecSyncPolicyArgs(
                        sync_options=[
                            "PrunePropagationPolicy=undefined",
                            "CreateNamespace=false",
                            "Validate=false",
                            "skipSchemaValidations=false",
                            "autoCreateNamespace=false",
                            "pruneLast=false",
                            "applyOutofSyncOnly=false",
                            "Replace=false",
                            "retry=false",
                        ],
                    )],
                    sources=[harness.platform.GitOpsApplicationsApplicationSpecSourceArgs(
                        target_revision="master",
                        repo_url="https://github.com/willycoll/argocd-example-apps.git",
                        path="helm-guestbook",
                    )],
                    destinations=[harness.platform.GitOpsApplicationsApplicationSpecDestinationArgs(
                        namespace="namespace-123",
                        server="https://1.3.4.5",
                    )],
                )],
            )],
            project_id="project_id",
            org_id="org_id",
            account_id="account_id",
            identifier="identifier",
            cluster_id="cluster_id",
            repo_id="repo_id",
            agent_id="agent_id")
        ```

        ## Import

        Import a Project level Gitops Application

        ```sh
        $ pulumi import harness:platform/gitOpsApplications:GitOpsApplications example <organization_id>/<project_id>/<agent_id>/<app_name>
        ```

        :param str resource_name: The name of the resource.
        :param GitOpsApplicationsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GitOpsApplicationsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_id: Optional[pulumi.Input[str]] = None,
                 agent_id: Optional[pulumi.Input[str]] = None,
                 applications: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GitOpsApplicationsApplicationArgs']]]]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 identifier: Optional[pulumi.Input[str]] = None,
                 kind: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 options_remove_existing_finalizers: Optional[pulumi.Input[bool]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[str]] = None,
                 query_project: Optional[pulumi.Input[str]] = None,
                 query_refresh: Optional[pulumi.Input[str]] = None,
                 query_repo: Optional[pulumi.Input[str]] = None,
                 query_resource_version: Optional[pulumi.Input[str]] = None,
                 query_selector: Optional[pulumi.Input[str]] = None,
                 repo_id: Optional[pulumi.Input[str]] = None,
                 request_cascade: Optional[pulumi.Input[bool]] = None,
                 request_name: Optional[pulumi.Input[str]] = None,
                 request_propagation_policy: Optional[pulumi.Input[str]] = None,
                 upsert: Optional[pulumi.Input[bool]] = None,
                 validate: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GitOpsApplicationsArgs.__new__(GitOpsApplicationsArgs)

            if account_id is None and not opts.urn:
                raise TypeError("Missing required property 'account_id'")
            __props__.__dict__["account_id"] = account_id
            if agent_id is None and not opts.urn:
                raise TypeError("Missing required property 'agent_id'")
            __props__.__dict__["agent_id"] = agent_id
            if applications is None and not opts.urn:
                raise TypeError("Missing required property 'applications'")
            __props__.__dict__["applications"] = applications
            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            __props__.__dict__["identifier"] = identifier
            __props__.__dict__["kind"] = kind
            __props__.__dict__["name"] = name
            __props__.__dict__["options_remove_existing_finalizers"] = options_remove_existing_finalizers
            if org_id is None and not opts.urn:
                raise TypeError("Missing required property 'org_id'")
            __props__.__dict__["org_id"] = org_id
            __props__.__dict__["project"] = project
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["query_project"] = query_project
            __props__.__dict__["query_refresh"] = query_refresh
            __props__.__dict__["query_repo"] = query_repo
            __props__.__dict__["query_resource_version"] = query_resource_version
            __props__.__dict__["query_selector"] = query_selector
            if repo_id is None and not opts.urn:
                raise TypeError("Missing required property 'repo_id'")
            __props__.__dict__["repo_id"] = repo_id
            __props__.__dict__["request_cascade"] = request_cascade
            __props__.__dict__["request_name"] = request_name
            __props__.__dict__["request_propagation_policy"] = request_propagation_policy
            __props__.__dict__["upsert"] = upsert
            __props__.__dict__["validate"] = validate
        super(GitOpsApplications, __self__).__init__(
            'harness:platform/gitOpsApplications:GitOpsApplications',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_id: Optional[pulumi.Input[str]] = None,
            agent_id: Optional[pulumi.Input[str]] = None,
            applications: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GitOpsApplicationsApplicationArgs']]]]] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            identifier: Optional[pulumi.Input[str]] = None,
            kind: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            options_remove_existing_finalizers: Optional[pulumi.Input[bool]] = None,
            org_id: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[str]] = None,
            project_id: Optional[pulumi.Input[str]] = None,
            query_project: Optional[pulumi.Input[str]] = None,
            query_refresh: Optional[pulumi.Input[str]] = None,
            query_repo: Optional[pulumi.Input[str]] = None,
            query_resource_version: Optional[pulumi.Input[str]] = None,
            query_selector: Optional[pulumi.Input[str]] = None,
            repo_id: Optional[pulumi.Input[str]] = None,
            request_cascade: Optional[pulumi.Input[bool]] = None,
            request_name: Optional[pulumi.Input[str]] = None,
            request_propagation_policy: Optional[pulumi.Input[str]] = None,
            upsert: Optional[pulumi.Input[bool]] = None,
            validate: Optional[pulumi.Input[bool]] = None) -> 'GitOpsApplications':
        """
        Get an existing GitOpsApplications resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: Account identifier of the GitOps application.
        :param pulumi.Input[str] agent_id: Agent identifier of the GitOps application.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GitOpsApplicationsApplicationArgs']]]] applications: Definition of the GitOps application resource.
        :param pulumi.Input[str] cluster_id: Cluster identifier of the GitOps application.
        :param pulumi.Input[str] identifier: Identifier of the GitOps application.
        :param pulumi.Input[str] kind: Kind of the GitOps application.
        :param pulumi.Input[str] name: Name of the GitOps application.
        :param pulumi.Input[bool] options_remove_existing_finalizers: Options to remove existing finalizers to delete the GitOps application.
        :param pulumi.Input[str] org_id: Organization identifier of the GitOps application.
        :param pulumi.Input[str] project: Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        :param pulumi.Input[str] project_id: Project identifier of the GitOps application.
        :param pulumi.Input[str] query_project: Project names to filter the corresponding GitOps applications.
        :param pulumi.Input[str] query_refresh: Forces the GitOps application to reconcile when set to true.
        :param pulumi.Input[str] query_repo: Repo URL to restrict returned list applications.
        :param pulumi.Input[str] query_resource_version: Shows modifications after a version that is specified with a watch call.
        :param pulumi.Input[str] query_selector: Filters GitOps applications corresponding to the labels.
        :param pulumi.Input[str] repo_id: Repository identifier of the GitOps application.
        :param pulumi.Input[bool] request_cascade: Request cascade to delete the GitOps application.
        :param pulumi.Input[str] request_name: Request name to delete the GitOps application.
        :param pulumi.Input[str] request_propagation_policy: Request propagation policy to delete the GitOps application.
        :param pulumi.Input[bool] upsert: Indicates if the GitOps application should be updated if existing and inserted if not.
        :param pulumi.Input[bool] validate: Indicates if the GitOps application has to be validated.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GitOpsApplicationsState.__new__(_GitOpsApplicationsState)

        __props__.__dict__["account_id"] = account_id
        __props__.__dict__["agent_id"] = agent_id
        __props__.__dict__["applications"] = applications
        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["identifier"] = identifier
        __props__.__dict__["kind"] = kind
        __props__.__dict__["name"] = name
        __props__.__dict__["options_remove_existing_finalizers"] = options_remove_existing_finalizers
        __props__.__dict__["org_id"] = org_id
        __props__.__dict__["project"] = project
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["query_project"] = query_project
        __props__.__dict__["query_refresh"] = query_refresh
        __props__.__dict__["query_repo"] = query_repo
        __props__.__dict__["query_resource_version"] = query_resource_version
        __props__.__dict__["query_selector"] = query_selector
        __props__.__dict__["repo_id"] = repo_id
        __props__.__dict__["request_cascade"] = request_cascade
        __props__.__dict__["request_name"] = request_name
        __props__.__dict__["request_propagation_policy"] = request_propagation_policy
        __props__.__dict__["upsert"] = upsert
        __props__.__dict__["validate"] = validate
        return GitOpsApplications(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[str]:
        """
        Account identifier of the GitOps application.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="agentId")
    def agent_id(self) -> pulumi.Output[str]:
        """
        Agent identifier of the GitOps application.
        """
        return pulumi.get(self, "agent_id")

    @property
    @pulumi.getter
    def applications(self) -> pulumi.Output[Sequence['outputs.GitOpsApplicationsApplication']]:
        """
        Definition of the GitOps application resource.
        """
        return pulumi.get(self, "applications")

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        Cluster identifier of the GitOps application.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter
    def identifier(self) -> pulumi.Output[Optional[str]]:
        """
        Identifier of the GitOps application.
        """
        return pulumi.get(self, "identifier")

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Output[Optional[str]]:
        """
        Kind of the GitOps application.
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the GitOps application.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="optionsRemoveExistingFinalizers")
    def options_remove_existing_finalizers(self) -> pulumi.Output[Optional[bool]]:
        """
        Options to remove existing finalizers to delete the GitOps application.
        """
        return pulumi.get(self, "options_remove_existing_finalizers")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Output[str]:
        """
        Organization identifier of the GitOps application.
        """
        return pulumi.get(self, "org_id")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[Optional[str]]:
        """
        Reference to the project corresponding to this GitOps application. An empty string means that the GitOps application belongs to the 'default' project.
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[str]:
        """
        Project identifier of the GitOps application.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="queryProject")
    def query_project(self) -> pulumi.Output[Optional[str]]:
        """
        Project names to filter the corresponding GitOps applications.
        """
        return pulumi.get(self, "query_project")

    @property
    @pulumi.getter(name="queryRefresh")
    def query_refresh(self) -> pulumi.Output[Optional[str]]:
        """
        Forces the GitOps application to reconcile when set to true.
        """
        return pulumi.get(self, "query_refresh")

    @property
    @pulumi.getter(name="queryRepo")
    def query_repo(self) -> pulumi.Output[Optional[str]]:
        """
        Repo URL to restrict returned list applications.
        """
        return pulumi.get(self, "query_repo")

    @property
    @pulumi.getter(name="queryResourceVersion")
    def query_resource_version(self) -> pulumi.Output[Optional[str]]:
        """
        Shows modifications after a version that is specified with a watch call.
        """
        return pulumi.get(self, "query_resource_version")

    @property
    @pulumi.getter(name="querySelector")
    def query_selector(self) -> pulumi.Output[Optional[str]]:
        """
        Filters GitOps applications corresponding to the labels.
        """
        return pulumi.get(self, "query_selector")

    @property
    @pulumi.getter(name="repoId")
    def repo_id(self) -> pulumi.Output[str]:
        """
        Repository identifier of the GitOps application.
        """
        return pulumi.get(self, "repo_id")

    @property
    @pulumi.getter(name="requestCascade")
    def request_cascade(self) -> pulumi.Output[Optional[bool]]:
        """
        Request cascade to delete the GitOps application.
        """
        return pulumi.get(self, "request_cascade")

    @property
    @pulumi.getter(name="requestName")
    def request_name(self) -> pulumi.Output[Optional[str]]:
        """
        Request name to delete the GitOps application.
        """
        return pulumi.get(self, "request_name")

    @property
    @pulumi.getter(name="requestPropagationPolicy")
    def request_propagation_policy(self) -> pulumi.Output[Optional[str]]:
        """
        Request propagation policy to delete the GitOps application.
        """
        return pulumi.get(self, "request_propagation_policy")

    @property
    @pulumi.getter
    def upsert(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates if the GitOps application should be updated if existing and inserted if not.
        """
        return pulumi.get(self, "upsert")

    @property
    @pulumi.getter
    def validate(self) -> pulumi.Output[Optional[bool]]:
        """
        Indicates if the GitOps application has to be validated.
        """
        return pulumi.get(self, "validate")

